#ifndef __CDROM_HANDLER_H__
#define __CDROM_HANDLER_H__

#include <glib.h>
#include <sys/param.h>

#define MAX_TRACKS 64

struct track_info {
	gboolean selected;
	gint track;		/* track number */
	gint wavsize;		/* projected wavfile size */
	gint start_pos;		/* start position in secs */
	gint start_frame;
	gint channels;
	gchar *time;
	gchar *artist;
	gchar *title;
	gchar *album;
	gchar *year;
	gchar *comment;
	gchar *genre;
	gchar *openfile;
	gchar *savefile;
};

extern GSList *tracks_list;
extern struct gr_progress *ripprogress;

gint cdrom_scan(void);
void *cdrom_get_track(void *data);
void cdrom_get_stats(void);

#endif				/* __CDROM_HANDLER_H__ */
