#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <gnome.h>
#include "error.h"

gint gr_errno;
gchar gr_errstr[MAXPATHLEN];

static void show_err(gchar * msg);
static gboolean usestr;

void gr_error(void)
{
	switch (gr_errno) {
	case GR_ENOCDROM:
		usestr = FALSE;
		show_err("Cannot initialze CD-ROM!");
		break;
	case GR_EFUCKDEV:
		usestr = FALSE;
		show_err
		    ("Couldn't find a way to read audio from this drive!");
		break;
	case GR_ENOAUDIO:
		usestr = FALSE;
		show_err("No AudioCD in device!");
		break;
	case GR_GENERRDEV:
		usestr = FALSE;
		show_err("Unable to open CD-ROM!");
		break;
	case GR_ECANTMKDIR:
		usestr = TRUE;
		show_err("Cannot create directory!");
		break;
	case GR_ECANTOGGINIT:
		usestr = FALSE;
		show_err("Cannot initialize Vorbis!");
		break;
	case GR_ESAVESETTINGS:
		usestr = FALSE;
		show_err("Cannot save settings!");
		break;
	}
}

static void show_err(gchar * msg)
{
	gchar str[1024];
	GtkWidget *msg_box;

	if (usestr == FALSE)
		sprintf(str, "%s", msg);
	else
		sprintf(str, "%s\n%s", msg, gr_errstr);

	msg_box = gnome_message_box_new(str, GNOME_MESSAGE_BOX_ERROR,
					GNOME_STOCK_BUTTON_OK, NULL);
	gtk_widget_show_all(msg_box);
}
