/*
 * Copyright 2002 (C) Michal Zawalich <michuz@pld.org.pl>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "interface.h"
#include "cdrom_handler.h"
#include "settings.h"

static void gr_init(void);
/********************************************************************/
int main(int argc, char *argv[])
{
	GtkWidget *window;

#ifdef ENABLE_NLS
	bindtextdomain(PACKAGE, PACKAGE_LOCALE_DIR);
	textdomain(PACKAGE);
#endif

	gnome_init("ripper", VERSION, argc, argv);

	window = create_application();
	gr_init();
	gtk_widget_show_all(window);

	gtk_main();
	return 0;
}

/********************************************************************/
static void gr_init(void)
{
	settings_set_default();
	settings_load();
	state.cd = TRUE;
	state.scan = FALSE;
	state.ripped = FALSE;
	state.cdparanoia_mutex = g_mutex_new();
	state.vorbis_mutex = g_mutex_new();
	state.progress_state = PROGRESS_ABORT;
	state.cddb_server = g_strdup_printf("freedb.freedb.org");
	state.cddb_cgi = g_strdup_printf("~cddb/cddb.cgi");
	state.cddb_program = g_strdup_printf("gripper");
	state.cddb_version = g_strdup_printf("0.1.0");
	gnome_appbar_push(GNOME_APPBAR(appbar), "Ready!");
}
