#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <gnome.h>
#include "interface.h"
#include "progress.h"
#include "error.h"
#include "settings.h"

struct gr_progress progress;

static void on_progress_cancel(GtkDialog *dialog, gint id, gpointer data);
/********************************************************************/
void gr_progress_new(gchar * label)
{
	GtkWidget *vbox;
	GtkWidget *oper_vbox;
	GtkWidget *htable = gtk_table_new(1, 2, FALSE);
	GtkWidget *image = gtk_image_new_from_file(PACKAGE_PIXMAPS_DIR "rippl-progress.png");
	GtkWidget *frame = gtk_frame_new("Processing");

	oper_vbox = gtk_vbox_new(FALSE, BORDER_NONE);
	progress.cancel = FALSE;
	progress.window = gtk_dialog_new_with_buttons(PACKAGE " processing...", GTK_WINDOW(application), GTK_DIALOG_DESTROY_WITH_PARENT, GTK_STOCK_CANCEL, GTK_RESPONSE_REJECT, NULL);
	progress.label1 = gtk_label_new(label);
	progress.label2 = gtk_label_new(NULL);
	progress.progress1 = gtk_progress_bar_new();
	progress.progress2 = gtk_progress_bar_new();
	vbox = GTK_DIALOG(progress.window)->vbox;

	/* label frame */
	gtk_container_add(GTK_CONTAINER(frame), oper_vbox);
	gtk_box_pack_start(GTK_BOX(oper_vbox), progress.label1, FALSE, FALSE, BORDER_NONE);
	gtk_box_pack_start(GTK_BOX(oper_vbox), progress.label2, FALSE, FALSE, BORDER_SMALL);
	gtk_box_pack_start(GTK_BOX(oper_vbox), progress.progress1, FALSE, FALSE, BORDER_NONE);
	gtk_box_pack_start(GTK_BOX(oper_vbox), progress.progress2, FALSE, FALSE, BORDER_NONE);
	gtk_table_attach(GTK_TABLE(htable), frame, 0, 1, 0, 1, GTK_FILL | GTK_EXPAND, GTK_FILL | GTK_EXPAND, BORDER_SMALL, BORDER_SMALL);
	gtk_table_attach(GTK_TABLE(htable), image, 1, 2, 0, 1, GTK_SHRINK, GTK_SHRINK, BORDER_SMALL, BORDER_SMALL);
	gtk_box_pack_start(GTK_BOX(vbox), htable, FALSE, FALSE, BORDER_NONE);

	gtk_window_set_default_size(GTK_WINDOW(progress.window), 500, 200);
	gtk_container_set_border_width(GTK_CONTAINER(oper_vbox), BORDER_BIG);
	gtk_misc_set_alignment(GTK_MISC(progress.label1), 0, 1);
	gtk_misc_set_alignment(GTK_MISC(progress.label2), 0, 1);

	g_signal_connect(progress.window, "response", G_CALLBACK(on_progress_cancel), NULL);
//	g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(on_progress_cancel), NULL);
//	g_signal_connect(G_OBJECT(progress.window), "delete_event", G_CALLBACK(on_progress_cancel), NULL);

	gtk_widget_show_all(progress.window);
}

/********************************************************************/
void gr_progress_update(gint percent1, gint percent2, gchar * progresstext)
{
	if (percent1 > 100)
		percent1 = 100;

	if (percent2 > 100)
		percent2 = 100;

	if (progress.window == NULL)
		return;

	gtk_label_set_text(GTK_LABEL(progress.label1),
			   state.progress_label1);
	gtk_label_set_text(GTK_LABEL(progress.label2),
			   state.progress_label2);
	gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR
				      (progress.progress1),
				      (gdouble) percent1 / 100);
	gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR
				      (progress.progress2),
				      (gdouble) percent2 / 100);
	gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progress.progress1),
				  progresstext);
	gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progress.progress2),
				  g_strdup_printf("%d%%", percent2));
}

/********************************************************************/
void gr_progress_destroy(struct gr_progress *progress)
{
	gtk_widget_destroy(progress->window);
	progress->window = NULL;
}

/********************************************************************/
static void on_progress_cancel(GtkDialog *dialog, gint id, gpointer data)
{
	switch (id) {
	case GTK_RESPONSE_REJECT:
		state.progress_state = PROGRESS_ABORT;
		break;
	}
}

