#ifndef __SETTINGS_H__
#define __SETTINGS_H__

#include <sys/param.h>
#include <glib.h>
#include <pthread.h>

enum {
	CDDB_MATCH_EXACT,
	CDDB_MATCH_INEXACT,
	CDDB_MATCH_NOMATCH
};

enum {
	PROGRESS_ABORT,
	PROGRESS_WAV,
	PROGRESS_VORBIS,
	PROGRESS_MP3,
	PROGRESS_AAC
};

/* some global switches */
typedef struct {
	gchar *general_cdrom_path;  /* cdrom device path */
	gchar *general_name_format; /* output filename format */

	gint vorbis_quality;        /* 100 - high, 1 - low */
	gint vorbis_channels;       /* 6 - 5.1, 2 - stereo, 1 - mono */

	gboolean cd;		/* TRUE if rip from cd */
	gboolean scan;		/* TRUE if cd was scanned */
	gboolean ripped;	/* TRUE if cd was ripped */

	gint totalsize;		/* total size selected files */
	gint ripsize;		/* size ripped tracks */
	gint leadout_pos;	/* leadout position in secs */

	gchar *cddb_server;
	gchar *cddb_cgi;
	gchar *cddb_program;
	gchar *cddb_version;
	gint cddb_list_genre;
	gint cddb_list_id;
	gchar cddb_list_title[64];
	gchar cddb_list_artist[64];
	gint cddb_match;

	/* progress bar stuff */
	gint progress;		/* progress in percent */
	gint progress2;		/* progress in percent */
	gchar *progress_text;	/* text on progress widget */
	gchar *progress_label1;	/* input label */
	gchar *progress_label2;	/* output label */
	gint progress_state;

	/* thread stuff */
	pthread_t thread;	/* cdparanoia thread */
	GMutex *cdparanoia_mutex;	/* cdparanoia mutex */
	GMutex *vorbis_mutex;	/* ogg vorbis mutex */
} state_t;

extern state_t state;

void settings_set_default(void);
void settings_load(void);
void settings_save(void);
void create_settings_window(void);

#endif				/* __SETTINGS_H__ */
