#include "progress.h"
#include "cdrom_handler.h"
#include "settings.h"
#include "vorbis_cb.h"
#include "vorbis_handler.h"
#include "wav_cb.h"

static gint vorbis_update(gpointer data);
static gint wait_for_cdparanoia(gpointer data);

/********************************************************************/
static gint vorbis_update(gpointer data)
{

	if ((state.progress_state > PROGRESS_ABORT) && (progress.window == NULL))
		gr_progress_new("");

	gr_progress_update(state.progress, state.progress2,
			   state.progress_text);

	if ((state.totalsize != 0) && (state.totalsize == state.ripsize)
	    && (state.progress_state == PROGRESS_VORBIS))
		state.progress_state = PROGRESS_ABORT;

	if (state.progress_state == PROGRESS_ABORT) {
		gr_progress_destroy(&progress);
		return (FALSE);
	}

	return (TRUE);
}

/********************************************************************/
static gint wait_for_cdparanoia(gpointer data)
{
	gint i;
	struct track_info *t;

	if (state.totalsize == 0)
		return (TRUE);

	if (state.totalsize == state.ripsize) {
		state.ripsize = 0;
		/* encoding tracks */
		for (i = 1; i <= g_slist_length(tracks_list); i++) {
			t = g_slist_nth_data(tracks_list, i - 1);
			if (t->selected == TRUE) {
				pthread_create(&state.thread, NULL,
					       gr_vorbis_encode, (void *)
					       GINT_TO_POINTER(i));
				pthread_detach(state.thread);
				gtk_timeout_add(500, vorbis_update, NULL);
			}
		}
		state.scan = FALSE;
		return (FALSE);
	}

	return (TRUE);
}

/********************************************************************/
void on_toogg_activate(GtkMenuItem * menuitem, gpointer user_data)
{
	state.progress_state = PROGRESS_VORBIS;
	on_towav_activate2(menuitem, user_data);
	gtk_timeout_add(1000, wait_for_cdparanoia, NULL);
}
